//This is for all the character-specific data

local BASEHP = 20 //Starting HP
local EMERALDBONUS = 10 //HP gained from collecting an Emerald
local BOSSBONUS = 10 //HP gained from beating a Boss
local POINTBONUS = 5 //HP gained from 'leveling up'
local POINTSTOGETBONUS = 75000 //Points needed to 'level up'

rawset(_G, "healthdata", setmetatable({
	["sora"] = {20, 7, 8, 5, 50000},
	["sonic"] = {22, 12, 5, 4, 50000},
	["tails"] = {15, 8, 8, 6, 80000},
	["knuckles"] = {30, 10, 10, 10, 95000},
	["amy"] = {16, 5, 10, 3, 27500},
	["fang"] = {10, 4, 4, 5, 62500},
	["metalsonic"] = {25, 5, 0, 7, 55000},
	["flicky"] = {5, 5, 5, 2, 27500},
	["hedgie"] = {10, 10, 10, 5, 50000},
	["SMS"] = {50, 0, 15, 5, 50000}
}, {__index = function() return {BASEHP, EMERALDBONUS, BOSSBONUS, POINTBONUS, POINTSTOGETBONUS} end}))

local BASERP = 4 //Starting RP (MP)
local EMERALDRPBONUS = 1 //Bonus RP for each Emerald
local BOSSRPBONUS = 1 //Bonus RP for defeating a Boss
local POINTSTOGETEXTRARP = 125000 //Points needed to gain another RP

rawset(_G, "ringdata", setmetatable({
	["sora"] = {4, 1, 1, 135000},
	["sonic"] = {4, 2, 0, 250000},
	["tails"] = {4, 1, 1, 87500},
	["knuckles"] = {1, 2, 1, 175000},
	["amy"] = {5, 1, 1, 115000},
	["fang"] = {2, 2, 0, 127500},
	["metalsonic"] = {0, 3, 0, -1},
	["flicky"] = {8, 1, 0, 75000},
	["hedgie"] = {8, 1, 2, 250000},
	["SMS"] = {5, 1, 1, -1}
}, {__index = function() return {BASERP, EMERALDRPBONUS, BOSSRPBONUS, POINTSTOGETEXTRARP} end}))


local startingstr = setmetatable({
	["sonic"] = 4,
	["tails"] = 3,
	["knuckles"] = 5,
	["amy"] = 3,
	["fang"] = 4,
	["metalsonic"] = 4,
	["SMS"] = 10
}, {__index = function() return 4 end})

local strincreases = setmetatable({
	["sonic"] = {[10] = 1, [20] = 1, [30] = 1, [40] = 1, [50] = 1, [60] = 1, [70] = 1, [80] = 1, [90] = 1, [99] = 1},
	["SMS"] = {[20] = 1, [40] = 1, [60] = 1, [75] = 1, [99] = 6}
}, {__index = function() return {[10] = 1, [20] = 1, [30] = 1, [40] = 1, [50] = 1, [60] = 1, [70] = 1, [80] = 1, [90] = 1, [99] = 1} end})

local startingmag = setmetatable({
	["sonic"] = 4,
	["tails"] = 6,
	["knuckles"] = 2,
	["amy"] = 5,
	["fang"] = 2,
	["metalsonic"] = 3,
	["SMS"] = 10
}, {__index = function() return 4 end})

local magincreases = setmetatable({
	["sonic"] = {[10] = 1, [20] = 1, [30] = 1, [40] = 1, [50] = 1, [60] = 1, [70] = 1, [80] = 1, [90] = 1, [99] = 1},
	["SMS"] = {[10] = 1, [30] = 1, [50] = 1, [70] = 1, [90] = 1, [99] = 5}
}, {__index = function() return {[10] = 1, [20] = 1, [30] = 1, [40] = 1, [50] = 1, [60] = 1, [70] = 1, [80] = 1, [90] = 1, [99] = 1} end})


rawset(_G, "getstr", function(p)
	if not p then return end
	if not p.mo then return end
	if not p.mo.skin then return end
	if not p.kh then return end
	local skin = p.mo.skin
	local str = startingstr[skin]
	local level
	if not p.kh.level or khBlastDiffTable[khBlastDiff][5] then
		level = 1
	else
		level = p.kh.level
	end
	local i = 1
	for i = 1, min(99, level)
		if strincreases[skin][i]
			str = $ + strincreases[skin][i]
		end
	end
	return str
end)

rawset(_G, "getmag", function(p)
	if not p then return end
	if not p.mo then return end
	if not p.mo.skin then return end
	if not p.kh then return end
	local skin = p.mo.skin
	local mag = startingmag[skin]
	local level
	if not p.kh.level or khBlastDiffTable[khBlastDiff][5] then
		level = 1
	else
		level = p.kh.level
	end
	local i = 1
	for i = 1, min(99, level)
		if magincreases[skin][i]
			mag = $ + strincreases[skin][i]
		end
	end
	return mag
end)

addHook("ThinkFrame", do
	for player in players.iterate do
		//Make sure characters can't attack using jumping
		/*
		if not (player.charflags & (SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)) then 
			player.charflags = $|SF_NOJUMPSPIN|SF_NOJUMPDAMAGE
		end
		*/
		
		//Enable Drive Forms
		if not (player.charflags & SF_SUPER) then 
			player.charflags = $|SF_SUPER
		end
		
		
		//Limit abilities to JumpThok, Swim, JumpBoost and DoubleJump
		/*
		if (player.charability == CA_THOK) or (player.charability == CA_HOMINGTHOK) or (player.charability == CA_JUMPTHOK) then
			player.charability = CA_JUMPTHOK
		elseif (player.charability == CA_SWIM) or (player.charability == CA_FLY) then
			player.charability = CA_SWIM
		elseif (player.charability != CA_DOUBLEJUMP) and (player.charability != CA_JUMPBOOST) then
			player.charability = CA_DOUBLEJUMP
		end
		
		if player.charability2 == CA2_NONE then //Make sure they can still attack on the ground though
			player.charability2 = CA2_MELEE
		end
		*/
	end
end)